package dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Locale;

import javax.print.DocFlavor.STRING;

import dto.FeedBoyas;
import dto.FeedPlayas;
import dto.FeedSample;
import dto.FeedSensores;


public class Project {
	public ArrayList<FeedPlayas> GetPlayas(Connection connection)
			throws Exception {
		ArrayList<FeedPlayas> feedData = new ArrayList<FeedPlayas>();
		try {
			PreparedStatement ps = connection
					.prepareStatement("SELECT id,nombre FROM playa ORDER BY id ASC");
			ResultSet rs = ps.executeQuery();
			while (rs.next()) {
				FeedPlayas feedPlayasObject = new FeedPlayas();
				feedPlayasObject.setId(rs.getString("id"));
				feedPlayasObject.setNombre(rs.getString("nombre"));
				feedData.add(feedPlayasObject);
			}
			return feedData;
		} catch (Exception e) {
			throw e;
		}
	}
	
	public ArrayList<FeedBoyas> GetBoyas(Connection connection)
			throws Exception {
		ArrayList<FeedBoyas> feedData = new ArrayList<FeedBoyas>();
		try {
			PreparedStatement ps = connection
					.prepareStatement("SELECT id,tag,playa FROM boya ORDER BY id ASC");
			ResultSet rs = ps.executeQuery();
			while (rs.next()) {
				FeedBoyas feedBoyasObject = new FeedBoyas();
				feedBoyasObject.setId(rs.getString("id"));
				feedBoyasObject.setTag(rs.getString("tag"));
				feedBoyasObject.setPlaya(rs.getString("playa"));
				feedData.add(feedBoyasObject);
			}
			return feedData;
		} catch (Exception e) {
			throw e;
		}
	}
	
	public ArrayList<FeedBoyas> GetBoyasByIdPlaya(Connection connection, String idPlaya)
			throws Exception {
		ArrayList<FeedBoyas> feedData = new ArrayList<FeedBoyas>();
		try {
			PreparedStatement ps = connection
					.prepareStatement("SELECT id,tag,playa " +
									  "FROM Boya.boya " +
									  "WHERE playa=" + idPlaya);
			ResultSet rs = ps.executeQuery();
			
			while (rs.next()) {
				FeedBoyas feedBoyasObject = new FeedBoyas();
				feedBoyasObject.setId(rs.getString("id"));
				feedBoyasObject.setTag(rs.getString("tag"));
				feedData.add(feedBoyasObject);
			}
			return feedData;
		} catch (Exception e) {
			throw e;
		}
	}
	
	public ArrayList<FeedSensores> GetSensores(Connection connection)
			throws Exception {
		ArrayList<FeedSensores> feedData = new ArrayList<FeedSensores>();
		try {
			PreparedStatement ps = connection
					.prepareStatement("SELECT id,boya,tipo,rango,comentario FROM sensor ORDER BY id ASC");
			ResultSet rs = ps.executeQuery();
			while (rs.next()) {
				FeedSensores feedSensorsObject = new FeedSensores();
				feedSensorsObject.setId(rs.getString("id"));
				feedSensorsObject.setBoya(rs.getString("boya"));
				feedSensorsObject.setTipo(rs.getString("tipo"));
				feedSensorsObject.setTipo(rs.getString("rango"));
				feedSensorsObject.setTipo(rs.getString("comentario"));				
				feedData.add(feedSensorsObject);
			}
			return feedData;
		} catch (Exception e) {
			throw e;
		}
	}
	
	public ArrayList<FeedSensores> GetSensoresByIdBoya(Connection connection, String idBoya)
			throws Exception {
		ArrayList<FeedSensores> feedData = new ArrayList<FeedSensores>();
		try {
			PreparedStatement ps = connection
					.prepareStatement("SELECT S.id,S.tipo,S.boya,T.id,T.nombre " +
									  "FROM Boya.sensor S, Boya.tipoSen T " +
									  "WHERE T.id = S.tipo " + 
									  "AND S.boya = "+ idBoya + " ORDER BY S.id ASC");
			ResultSet rs = ps.executeQuery();
			while (rs.next()) {
				FeedSensores feedSensoresObject = new FeedSensores();
				feedSensoresObject.setId(rs.getString("S.id"));
				feedSensoresObject.setTipo(rs.getString("T.nombre"));
				feedData.add(feedSensoresObject);
			}
			return feedData;
		} catch (Exception e) {
			throw e;
		}
	}
	// --------------- Ajustar El INSERT !!!!
	public void setSensorValueById(Connection connection, String idSensor, String value)
			throws Exception {
		try {
			PreparedStatement ps = connection
					.prepareStatement("INSERT INTO Boya.sample " +
									  "(sensor,valor) values " + 
									  "('"+idSensor+"','"+value+"')");
			ps.executeUpdate();
		} catch (Exception e) {
			throw e;
		}
	}
	// -----------------------------------------------------------------------------------
	public FeedSample GetSample(Connection connection, String idSample)
			throws Exception {
		try {
			PreparedStatement ps = connection
					.prepareStatement("SELECT id,sensor,fecha AS fecha ,valor " +
									  "FROM Boya.sample " +
									  "WHERE fecha = (SELECT MAX(fecha) FROM Boya.sample WHERE sensor=" + idSample + ")");
			ResultSet rs = ps.executeQuery();
			FeedSample feedSampleObject = new FeedSample();
			//DateFormat df = DateFormat.getDateInstance(DateFormat.LONG, Locale.FRENCH);
			while (rs.next()) {
				feedSampleObject.setId(rs.getString("id"));
				feedSampleObject.setSensor(rs.getString("sensor"));
				feedSampleObject.setFecha(rs.getTimestamp("fecha").toString());
				feedSampleObject.setValue(String.valueOf(rs.getFloat(("valor"))));
			}
			return feedSampleObject;
		} catch (Exception e) {
			throw e;
		}
	}
}