package model;

import java.sql.Connection;
import java.util.ArrayList;

import dao.Database;
import dao.Project;
import dto.FeedBoyas;
import dto.FeedPlayas;
import dto.FeedSample;
import dto.FeedSensores;

public class ProjectManager {

	public ArrayList<FeedPlayas> GetPlayas() throws Exception {
		ArrayList<FeedPlayas> feeds = null;
		try {
			Database database = new Database();
			Connection connection = database.Get_Connection();
			Project project = new Project();
			feeds = project.GetPlayas(connection);
		} catch (Exception e) {
			throw e;
		}
		return feeds;
	}
	
	public ArrayList<FeedBoyas> GetBoyas() throws Exception {
		ArrayList<FeedBoyas> feeds = null;
		try {
			Database database = new Database();
			Connection connection = database.Get_Connection();
			Project project = new Project();
			feeds = project.GetBoyas(connection);
		} catch (Exception e) {
			throw e;
		}
		return feeds;
	}
	
	public ArrayList<FeedBoyas> GetBoyasByIdPlaya(String idPlaya) throws Exception {
		ArrayList<FeedBoyas> feeds = null;
		try {
			Database database = new Database();
			Connection connection = database.Get_Connection();
			Project project = new Project();
			feeds = project.GetBoyasByIdPlaya(connection, idPlaya);
		} catch (Exception e) {
			throw e;
		}
		return feeds;
	}
	
	public ArrayList<FeedSensores> GetSensores() throws Exception {
		ArrayList<FeedSensores> feeds = null;
		try {
			Database database = new Database();
			Connection connection = database.Get_Connection();
			Project project = new Project();
			feeds = project.GetSensores(connection);
		} catch (Exception e) {
			throw e;
		}
		return feeds;
	}
	
	public ArrayList<FeedSensores> GetSensoresByIdBoya(String idBoya) throws Exception {
		ArrayList<FeedSensores> feeds = null;
		try {
			Database database = new Database();
			Connection connection = database.Get_Connection();
			Project project = new Project();
			feeds = project.GetSensoresByIdBoya(connection, idBoya);
		} catch (Exception e) {
			throw e;
		}
		return feeds;
	}
	
	public void setSensorValueByIdSensor(String idSensor, String value) throws Exception {
		try {
			Database database = new Database();
			Connection connection = database.Get_Connection();
			Project project = new Project();
			project.setSensorValueById(connection, idSensor, value);
		} catch (Exception e) {
			throw e;
		}
	}
	
	public FeedSample GetSample(String idSensor) throws Exception {
		FeedSample feed = null;
		try {
			Database database = new Database();
			Connection connection = database.Get_Connection();
			Project project = new Project();
			feed = project.GetSample(connection, idSensor);
		} catch (Exception e) {
			throw e;
		}
		return feed;
	}

}
