package webService;

import java.util.ArrayList;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

import model.ProjectManager;
import com.google.gson.Gson;

import dto.FeedBoyas;
import dto.FeedPlayas;
import dto.FeedSample;
import dto.FeedSensores;

@Path("/WebService")
public class FeedService {

	@GET
	@Path("/GetPlayas")
	@Produces("application/json")
	public String playas() {
		String feeds = null;
		try {
			ArrayList<FeedPlayas> feedData = null;
			ProjectManager projectManager = new ProjectManager();
			feedData = projectManager.GetPlayas();
			Gson gson = new Gson();
			System.out.println(gson.toJson(feedData));
			feeds = gson.toJson(feedData);
		}

		catch (Exception e) {
			System.out.println("Exception Error"); // Console
		}
		return feeds;
	}
	
	@GET
	@Path("/GetBoyas")
	@Produces("application/json")
	public String boyas() {
		String feeds = null;
		try {
			ArrayList<FeedBoyas> feedData = null;
			ProjectManager projectManager = new ProjectManager();
			feedData = projectManager.GetBoyas();
			Gson gson = new Gson();
			System.out.println(gson.toJson(feedData));
			feeds = gson.toJson(feedData);
		}

		catch (Exception e) {
			System.out.println("Exception Error"); // Console
		}
		return feeds;
	}
	
	@GET
	@Path("/GetSensores")
	@Produces("text/plain")
	public String sensores() {
		String feeds = null;
		try {
			ArrayList<FeedSensores> feedData = null;
			ProjectManager projectManager = new ProjectManager();
			feedData = projectManager.GetSensores();
			Gson gson = new Gson();
			System.out.println(gson.toJson(feedData));
			feeds = gson.toJson(feedData);
		}

		catch (Exception e) {
			System.out.println("Exception Error"); // Console
		}
		return feeds;
	}
	
	@GET
	@Path("/GetSample")
	@Produces(MediaType.APPLICATION_JSON)
	public String sensor(@QueryParam("id") String idSensor) 
	    {
			
			String feeds = null;
			
			try {
				FeedSample feedData = null;
				ProjectManager projectManager = new ProjectManager();
				feedData = projectManager.GetSample(idSensor);
				Gson gson = new Gson();
				System.out.println(gson.toJson(feedData));
				feeds = gson.toJson(feedData);
				
			return feeds;
		}

		catch (Exception e) {
			System.out.println("Exception Error"); // Console
			return e.getMessage();
		}
		
	}
	
	@GET
	@Path("/GetBoyasByIdPlaya")
	@Produces("application/json")
	public String boyasByIdPlaya(@QueryParam("id") String idPlaya) {
		String feeds = null;
		try {
			ArrayList<FeedBoyas> feedData = null;
			ProjectManager projectManager = new ProjectManager();
			feedData = projectManager.GetBoyasByIdPlaya(idPlaya);
			Gson gson = new Gson();
			System.out.println(gson.toJson(feedData));
			feeds = gson.toJson(feedData);
		}

		catch (Exception e) {
			System.out.println("Exception Error"); // Console
		}
		return feeds;
	}
	
	@GET
	@Path("/GetSensoresByIdBoya")
	@Produces("application/json")
	public String sensoresByIdBoya(@QueryParam("id") String idBoya) {
		String feeds = null;
		try {
			ArrayList<FeedSensores> feedData = null;
			ProjectManager projectManager = new ProjectManager();
			feedData = projectManager.GetSensoresByIdBoya(idBoya);
			Gson gson = new Gson();
			System.out.println(gson.toJson(feedData));
			feeds = gson.toJson(feedData);
		}

		catch (Exception e) {
			System.out.println("Exception Error"); // Console
		}
		return feeds;
	}
	
	@GET
	@Path("/SetSensorValueById")
	@Produces("text/plain")
	public String setSensorValueById(@QueryParam("id") String idSensor,@QueryParam("value") String value) {
		try {
			ProjectManager projectManager = new ProjectManager();
			projectManager.setSensorValueByIdSensor(idSensor,value);
		}

		catch (Exception e) {
			System.out.println("Exception Error"); // Console
		}
		return "";
	}
	
	
	
}
